﻿Public Class MyICommand
    Implements ICommand

    Private _TargetExecuteMethod As Action
    Private _TargetCanExecuteMethod As Func(Of Boolean)

    Public Sub New(executeMethod As Action)
        _TargetExecuteMethod = executeMethod
    End Sub

    Public Sub New(executeMethod As Action, canExecuteMethod As Func(Of Boolean))
        _TargetExecuteMethod = executeMethod
        _TargetCanExecuteMethod = canExecuteMethod
    End Sub

    Public Sub RaiseCanExecuteChanged()
        CanExecuteChanged(Me, EventArgs.Empty)
    End Sub

    Private Function ICommand_CanExecute(parameter As Object) As Boolean Implements ICommand.CanExecute

        If _TargetCanExecuteMethod IsNot Nothing Then
            Return _TargetCanExecuteMethod()
        End If

        If _TargetExecuteMethod IsNot Nothing Then
            Return True
        End If

        Return False
    End Function

    ' Beware - should use weak references if command instance lifetime  is longer than lifetime of UI objects that get hooked up to command 
    ' Prism commands solve this in their implementation public event 
    Private CanExecuteChanged As EventHandler = Sub()
                                                End Sub

    Private Event ICommand_CanExecuteChanged As EventHandler Implements ICommand.CanExecuteChanged

    Private Sub ICommand_Execute(parameter As Object) Implements ICommand.Execute
        _TargetExecuteMethod()
    End Sub

End Class
