﻿Namespace VML

    Public Class ViewModelLocator

        Public Shared Function GetAutoHookedUpViewModel(obj As DependencyObject) As Boolean
            Return CBool(obj.GetValue(AutoHookedUpViewModelProperty))
        End Function

        Public Shared Sub SetAutoHookedUpViewModel(obj As DependencyObject, value As Boolean)
            obj.SetValue(AutoHookedUpViewModelProperty, value)
        End Sub

        'Using a DependencyProperty as the backing store for AutoHookedUpViewModel.
        'This enables animation, styling, binding, etc...

        Public Shared ReadOnly Property AutoHookedUpViewModelProperty As DependencyProperty =
            DependencyProperty.RegisterAttached("AutoHookedUpViewModel",
                                                GetType(Boolean),
                                                GetType(ViewModelLocator),
                                                New PropertyMetadata(False, AddressOf AutoHookedUpViewModelChanged))

        Private Shared Sub AutoHookedUpViewModelChanged(d As DependencyObject, e As DependencyPropertyChangedEventArgs)
            If ComponentModel.DesignerProperties.GetIsInDesignMode(d) Then
                Return
            End If
            Dim viewType = d.[GetType]()

            Dim str As String = viewType.FullName
            str = str.Replace(".Views.", ".ViewModel.")

            Dim viewTypeName = str
            Dim viewModelTypeName = viewTypeName & Convert.ToString("Model")
            Dim viewModelType = Type.[GetType](viewModelTypeName)
            Dim viewModel = Activator.CreateInstance(viewModelType)

            DirectCast(d, FrameworkElement).DataContext = viewModel
        End Sub


    End Class
End Namespace