﻿
Namespace ViewModel

    Public Class StudentViewModel

        Private m_Students As ObjectModel.ObservableCollection(Of Model.Student)
        Public Property Students() As ObjectModel.ObservableCollection(Of Model.Student)
            Get
                Return m_Students
            End Get
            Set
                m_Students = Value
            End Set
        End Property

        Public Property DeleteCommand() As MyICommand
            Get
                Return m_DeleteCommand
            End Get
            Set
                m_DeleteCommand = Value
            End Set
        End Property
        Private m_DeleteCommand As MyICommand

        Public Sub New()
            LoadStudents()
            DeleteCommand = New MyICommand(AddressOf OnDelete, AddressOf CanDelete)
        End Sub

        Public Sub LoadStudents()
            Dim students__1 As New ObjectModel.ObservableCollection(Of Model.Student)()

            students__1.Add(New Model.Student() With {
               .FirstName = "Mark",
                .LastName = "Allain"
            })
            students__1.Add(New Model.Student() With {
                .FirstName = "Allen",
                .LastName = "Brown"
            })
            students__1.Add(New Model.Student() With {
                .FirstName = "Linda",
                .LastName = "Hamerski"
            })

            Students = students__1
        End Sub

        Private _selectedStudent As Model.Student

        Public Property SelectedStudent() As Model.Student
            Get
                Return _selectedStudent
            End Get

            Set
                _selectedStudent = Value
                DeleteCommand.RaiseCanExecuteChanged()
            End Set
        End Property

        Private Sub OnDelete()
            Students.Remove(SelectedStudent)
        End Sub

        Private Function CanDelete() As Boolean
            Return True
            'Return (SelectedStudent IsNot Nothing)
        End Function
    End Class
End Namespace

